/*******************************************************************************************
 **                                www.bastelgarage.ch                                    **
 ** Der Onlineshop mit Videoanleitungen und kompletten Bausätzen für Anfänger und Profis! **
 *******************************************************************************************
 ** Autor: Alf Müller                                                                     **
 ** Datum: November 2018                                                                  **
 ** Version: Morsen V1.3                                                                  **
 ** Lizenz: CC BY-NC-ND 2.5 CH                                                            **
 *******************************************************************************************
*/

/************************( Importieren der genutzten Bibliotheken )************************/
#include "Arduino.h"

#define NUM_MAX 4

// for NodeMCU 1.0
#define DIN_PIN 15  // D8
#define CS_PIN  13  // D7
#define CLK_PIN 12  // D6
const int buttonPin = 4;  // D2
const int buzzer = 5;     // D1
const int ledPin = 2;     // D4

int ledState = HIGH;
int buttonState = LOW;
int lastButtonState = LOW;
int doesitwork = LOW;  // variable used for debuging early versions of the code



#include "max7219.h"
#include "fonts.h"

#define MAX_DIGITS 16
byte dig[MAX_DIGITS] = {0};
byte digold[MAX_DIGITS] = {0};
byte digtrans[MAX_DIGITS] = {0};
int dx = 0;
int dy = 0;

int pause_value = 250;  // Hier kannst du die Geschwindigkeit der zu erwartenden Eingabe verändern
long signal_length = 0;
long pause = 50;        // Hier kannst du die pause für den Leerschlags verändern

String morse = "";
String dash = "-";
String dot = "*";
String vartext = " ";


boolean cheker = false;
boolean linecheker = false;

long lastDebounceTime = 0;
long debounceDelay = 50;

/*****************************************( Setup )****************************************/
void setup()
{
  Serial.begin(115200);
  initMAX7219();
  sendCmdAll(CMD_SHUTDOWN, 1);
  sendCmdAll(CMD_INTENSITY, 0);
  printStringWithShift("Kannst du Morsen?                            ", 60);
  pinMode(buttonPin, INPUT);

}
/*************************************(Hauptprogramm)**************************************/
void loop()
{
  buttonState = digitalRead(buttonPin);
  
  if (signal_length > 3000) {
    // clearall();
    Serial.println("Alles Löschen");
    signal_length = 0;
    clr();
    refreshAll();
    while(digitalRead(buttonPin)==HIGH){
     delay(100);
    }
  }

  if (buttonState && lastButtonState)       // Grundzustand abhängig vom Zustand des Signals von der Taste
  {
    ++signal_length;
    if (signal_length < 2 * pause_value)    //Wenn sich die Signallänge ändert, kein Punkt mehr, sondern ein Strich
    {                                       
      tone(buzzer, 1500) ;
    }
    else
    {
      tone(buzzer, 1000) ;
    }
  }
  else if (!buttonState && lastButtonState)         //wenn die Taste losgelassen wird, wird entweder * oder - in den Puffer gesendet
  {

    if (signal_length > 50 && signal_length < 2 * pause_value )
    {
      morse =  morse + dot;
    }
    else if (signal_length > 2 * pause_value)
    {
      morse = morse +  dash;
    }
    signal_length = 0;
    //digitalWrite(13, LOW);
    noTone(buzzer);
  }
  else if (buttonState && !lastButtonState)         //  wenn die Taste gedrückt wird, werden die  Werte zurückgesetzt
  {
    pause = 0;
    //digitalWrite(13, HIGH);
    cheker = true;
    linecheker = true;
  }
  else if (!buttonState && !lastButtonState)
  {
    ++pause;
    if (( pause > 3 * pause_value ) && (cheker))
    {
      morseCode(morse);
      cheker = false;
      morse = "";
    }
    if ((pause > 15 * pause_value) && (linecheker))
    {
      Serial.println();
      linecheker = false;
      moveone();
    }
  }
  lastButtonState = buttonState;
  delay(1);
}
